diff -urN gcc-3.3.3.orig/gcc/config/sparc/t-linux64 gcc-3.3.3/gcc/config/sparc/t-linux64
--- gcc-3.3.3.orig/gcc/config/sparc/t-linux64	2002-10-08 15:59:45.000000000 -0600
+++ gcc-3.3.3/gcc/config/sparc/t-linux64	2004-04-20 02:29:00.000000000 -0600
@@ -17,3 +17,7 @@
 CRTSTUFF_T_CFLAGS = `if test x$$($(GCC_FOR_TARGET) $(MULTILIB_CFLAGS) \
 				 -print-multi-os-directory) \
 			= x../lib64; then echo -mcmodel=medany; fi`
+
+# Compile libgcc2.a with pic and for -m32 also IEEE quad long double.
+# -m64 implies -mlong-double-128, so this is no change for 64-bit.
+TARGET_LIBGCC2_CFLAGS = -fPIC -mlong-double-128
diff -urN gcc-3.3.3.orig/gcc/config/xtensa/xtensa-protos.h gcc-3.3.3/gcc/config/xtensa/xtensa-protos.h
--- gcc-3.3.3.orig/gcc/config/xtensa/xtensa-protos.h	2003-04-25 18:24:09.000000000 -0600
+++ gcc-3.3.3/gcc/config/xtensa/xtensa-protos.h	2004-04-20 02:29:00.000000000 -0600
@@ -1,5 +1,5 @@
 /* Prototypes of target machine for GNU compiler for Xtensa.
-   Copyright 2001,2002,2003 Free Software Foundation, Inc.
+   Copyright 2001, 2002, 2003, 2004 Free Software Foundation, Inc.
    Contributed by Bob Wilson (bwilson@tensilica.com) at Tensilica.
 
 This file is part of GCC.
@@ -70,14 +70,14 @@
 extern int xtensa_expand_scc PARAMS ((rtx *));
 extern int xtensa_expand_block_move PARAMS ((rtx *));
 extern int xtensa_emit_move_sequence PARAMS ((rtx *, enum machine_mode));
-extern bool xtensa_copy_incoming_a7 PARAMS ((rtx *, enum machine_mode));
+extern rtx xtensa_copy_incoming_a7 PARAMS ((rtx));
 extern void xtensa_emit_block_move PARAMS ((rtx *, rtx *, int));
 extern void xtensa_expand_nonlocal_goto PARAMS ((rtx *));
 extern void xtensa_emit_loop_end PARAMS ((rtx, rtx *));
 extern char * xtensa_emit_call PARAMS ((int, rtx *));
 
 #ifdef TREE_CODE
-extern void init_cumulative_args PARAMS ((CUMULATIVE_ARGS *, tree, rtx));
+extern void init_cumulative_args PARAMS ((CUMULATIVE_ARGS *, int));
 extern void xtensa_va_start PARAMS ((tree, rtx));
 extern rtx xtensa_va_arg PARAMS ((tree, tree));
 #endif /* TREE_CODE */
@@ -93,7 +93,6 @@
   PARAMS ((rtx, enum reg_class, int));
 extern enum reg_class xtensa_secondary_reload_class
   PARAMS ((enum reg_class, enum machine_mode, rtx, int));
-extern int a7_overlap_mentioned_p PARAMS ((rtx x));
 #endif /* RTX_CODE */
 
 #ifdef TREE_CODE
diff -urN gcc-3.3.3.orig/gcc/config/xtensa/xtensa.c gcc-3.3.3/gcc/config/xtensa/xtensa.c
--- gcc-3.3.3.orig/gcc/config/xtensa/xtensa.c	2003-04-25 18:24:09.000000000 -0600
+++ gcc-3.3.3/gcc/config/xtensa/xtensa.c	2004-04-20 02:29:00.000000000 -0600
@@ -1,5 +1,5 @@
 /* Subroutines for insn-output.c for Tensilica's Xtensa architecture.
-   Copyright 2001,2002,2003 Free Software Foundation, Inc.
+   Copyright 2001, 2002, 2003, 2004 Free Software Foundation, Inc.
    Contributed by Bob Wilson (bwilson@tensilica.com) at Tensilica.
 
 This file is part of GCC.
@@ -90,7 +90,9 @@
 struct machine_function GTY(())
 {
   int accesses_prev_frame;
-  bool incoming_a7_copied;
+  bool need_a7_copy;
+  bool vararg_a7;
+  rtx set_frame_ptr_insn;
 };
 
 /* Vector, indexed by hard register number, which contains 1 for a
@@ -1276,8 +1278,7 @@
       if (!xtensa_valid_move (mode, operands))
 	operands[1] = force_reg (mode, operands[1]);
 
-      if (xtensa_copy_incoming_a7 (operands, mode))
-	return 1;
+      operands[1] = xtensa_copy_incoming_a7 (operands[1]);
     }
 
   /* During reload we don't want to emit (subreg:X (mem:Y)) since that
@@ -1309,71 +1310,115 @@
 }
 
 
-/* Check if this move is copying an incoming argument in a7.  If so,
-   emit the move, followed by the special "set_frame_ptr"
-   unspec_volatile insn, at the very beginning of the function.  This
-   is necessary because the register allocator will ignore conflicts
-   with a7 and may assign some other pseudo to a7.  If that pseudo was
-   assigned prior to this move, it would clobber the incoming argument
-   in a7.  By copying the argument out of a7 as the very first thing,
-   and then immediately following that with an unspec_volatile to keep
-   the scheduler away, we should avoid any problems.  */
+/* Check if an incoming argument in a7 is expected to be used soon and
+   if OPND is a register or register pair that includes a7.  If so,
+   create a new pseudo and copy a7 into that pseudo at the very
+   beginning of the function, followed by the special "set_frame_ptr"
+   unspec_volatile insn.  The return value is either the original
+   operand, if it is not a7, or the new pseudo containing a copy of
+   the incoming argument.  This is necessary because the register
+   allocator will ignore conflicts with a7 and may either assign some
+   other pseudo to a7 or use a7 as the hard_frame_pointer, clobbering
+   the incoming argument in a7.  By copying the argument out of a7 as
+   the very first thing, and then immediately following that with an
+   unspec_volatile to keep the scheduler away, we should avoid any
+   problems.  Putting the set_frame_ptr insn at the beginning, with
+   only the a7 copy before it, also makes it easier for the prologue
+   expander to initialize the frame pointer after the a7 copy and to
+   fix up the a7 copy to use the stack pointer instead of the frame
+   pointer.  */
 
-bool
-xtensa_copy_incoming_a7 (operands, mode)
-     rtx *operands;
-     enum machine_mode mode;
+rtx
+xtensa_copy_incoming_a7 (opnd)
+     rtx opnd;
 {
-  if (a7_overlap_mentioned_p (operands[1])
-      && !cfun->machine->incoming_a7_copied)
+  rtx entry_insns = 0;
+  rtx reg, tmp;
+  enum machine_mode mode;
+
+  if (!cfun->machine->need_a7_copy)
+    return opnd;
+
+  /* This function should never be called again once a7 has been copied.  */
+  if (cfun->machine->set_frame_ptr_insn)
+    abort ();
+
+  mode = GET_MODE (opnd);
+
+  /* The operand using a7 may come in a later instruction, so just return
+     the original operand if it doesn't use a7.  */
+  reg = opnd;
+  if (GET_CODE (reg) == SUBREG)
     {
-      rtx mov;
-      switch (mode)
-	{
-	case DFmode:
-	  mov = gen_movdf_internal (operands[0], operands[1]);
-	  break;
-	case SFmode:
-	  mov = gen_movsf_internal (operands[0], operands[1]);
-	  break;
-	case DImode:
-	  mov = gen_movdi_internal (operands[0], operands[1]);
-	  break;
-	case SImode:
-	  mov = gen_movsi_internal (operands[0], operands[1]);
-	  break;
-	case HImode:
-	  mov = gen_movhi_internal (operands[0], operands[1]);
-	  break;
-	case QImode:
-	  mov = gen_movqi_internal (operands[0], operands[1]);
-	  break;
-	default:
-	  abort ();
-	}
+      if (SUBREG_BYTE (reg) != 0)
+	abort ();
+      reg = SUBREG_REG (reg);
+    }
+  if (GET_CODE (reg) != REG
+      || REGNO (reg) > A7_REG
+      || REGNO (reg) + HARD_REGNO_NREGS (A7_REG, mode) <= A7_REG)
+    return opnd;
 
-      /* Insert the instructions before any other argument copies.
-	 (The set_frame_ptr insn comes _after_ the move, so push it
-	 out first.)  */
-      push_topmost_sequence ();
-      emit_insn_after (gen_set_frame_ptr (), get_insns ());
-      emit_insn_after (mov, get_insns ());
-      pop_topmost_sequence ();
+  /* 1-word args will always be in a7; 2-word args in a6/a7.  */
+  if (REGNO (reg) + HARD_REGNO_NREGS (A7_REG, mode) - 1 != A7_REG)
+    abort ();
 
-      /* Ideally the incoming argument in a7 would only be copied
-	 once, since propagating a7 into the body of a function
-	 will almost certainly lead to errors.  However, there is
-	 at least one harmless case (in GCSE) where the original
-	 copy from a7 is changed to copy into a new pseudo.  Thus,
-	 we use a flag to only do this special treatment for the
-	 first copy of a7.  */
+  cfun->machine->need_a7_copy = false;
 
-      cfun->machine->incoming_a7_copied = true;
+  /* Copy a7 to a new pseudo at the function entry.  Use gen_raw_REG to
+     create the REG for a7 so that hard_frame_pointer_rtx is not used.  */
 
-      return 1;
+  push_to_sequence (entry_insns);
+  tmp = gen_reg_rtx (mode);
+
+  switch (mode)
+    {
+    case DFmode:
+    case DImode:
+      emit_insn (gen_movsi_internal (gen_rtx_SUBREG (SImode, tmp, 0),
+				     gen_rtx_REG (SImode, A7_REG - 1)));
+      emit_insn (gen_movsi_internal (gen_rtx_SUBREG (SImode, tmp, 4),
+				     gen_raw_REG (SImode, A7_REG)));
+      break;
+    case SFmode:
+      emit_insn (gen_movsf_internal (tmp, gen_raw_REG (mode, A7_REG)));
+      break;
+    case SImode:
+      emit_insn (gen_movsi_internal (tmp, gen_raw_REG (mode, A7_REG)));
+      break;
+    case HImode:
+      emit_insn (gen_movhi_internal (tmp, gen_raw_REG (mode, A7_REG)));
+      break;
+    case QImode:
+      emit_insn (gen_movqi_internal (tmp, gen_raw_REG (mode, A7_REG)));
+      break;
+    default:
+      abort ();
     }
 
-  return 0;
+  cfun->machine->set_frame_ptr_insn = emit_insn (gen_set_frame_ptr ());
+  entry_insns = get_insns ();
+  end_sequence ();
+
+  if (cfun->machine->vararg_a7)
+    {
+      /* This is called from within builtin_savereg, so we're already
+	 inside a start_sequence that will be placed at the start of
+	 the function.  */
+      emit_insn (entry_insns);
+    }
+  else
+    {
+      /* Put entry_insns after the NOTE that starts the function.  If
+	 this is inside a start_sequence, make the outer-level insn
+	 chain current, so the code is placed at the start of the
+	 function.  */
+      push_topmost_sequence ();
+      emit_insn_after (entry_insns, get_insns ());
+      pop_topmost_sequence ();
+    }
+
+  return tmp;
 }
 
 
@@ -1721,12 +1766,12 @@
 /* Initialize CUMULATIVE_ARGS for a function.  */
 
 void
-init_cumulative_args (cum, fntype, libname)
+init_cumulative_args (cum, incoming)
      CUMULATIVE_ARGS *cum;	/* argument info to initialize */
-     tree fntype ATTRIBUTE_UNUSED;	/* tree ptr for function decl */
-     rtx libname ATTRIBUTE_UNUSED;	/* SYMBOL_REF of library name or 0 */
+     int incoming;
 {
   cum->arg_words = 0;
+  cum->incoming = incoming;
 }
 
 /* Advance the argument to the next argument position.  */
@@ -1767,7 +1812,6 @@
   int regbase, words, max;
   int *arg_words;
   int regno;
-  enum machine_mode result_mode;
 
   arg_words = &cum->arg_words;
   regbase = (incoming_p ? GP_ARG_FIRST : GP_OUTGOING_ARG_FIRST);
@@ -1784,33 +1828,11 @@
     return (rtx)0;
 
   regno = regbase + *arg_words;
-  result_mode = (mode == BLKmode ? TYPE_MODE (type) : mode);
 
-  /* We need to make sure that references to a7 are represented with
-     rtx that is not equal to hard_frame_pointer_rtx.  For BLKmode and
-     modes bigger than 2 words (because we only have patterns for
-     modes of 2 words or smaller), we can't control the expansion
-     unless we explicitly list the individual registers in a PARALLEL. */
-
-  if ((mode == BLKmode || words > 2)
-      && regno < A7_REG
-      && regno + words > A7_REG)
-    {
-      rtx result;
-      int n;
-
-      result = gen_rtx_PARALLEL (result_mode, rtvec_alloc (words));
-      for (n = 0; n < words; n++)
-	{
-	  XVECEXP (result, 0, n) =
-	    gen_rtx_EXPR_LIST (VOIDmode,
-			       gen_raw_REG (SImode, regno + n),
-			       GEN_INT (n * UNITS_PER_WORD));
-	}
-      return result;
-    }
+  if (cum->incoming && regno <= A7_REG && regno + words > A7_REG)
+    cfun->machine->need_a7_copy = true;
 
-  return gen_raw_REG (result_mode, regno);
+  return gen_rtx_REG (mode, regno);
 }
 
 
@@ -2187,8 +2209,6 @@
 xtensa_reorg (first)
     rtx first;
 {
-  rtx insn, set_frame_ptr_insn = 0;
-    
   unsigned long tsize = compute_frame_size (get_frame_size ());
   if (tsize < (1 << (12+3)))
     frame_size_const = 0;
@@ -2204,34 +2224,15 @@
   if (!frame_pointer_needed)
     return;
 
-  /* Search all instructions, looking for the insn that sets up the
-     frame pointer.  This search will fail if the function does not
-     have an incoming argument in $a7, but in that case, we can just
-     set up the frame pointer at the very beginning of the
-     function. */
-
-  for (insn = first; insn; insn = NEXT_INSN (insn))
-    {
-      rtx pat;
-
-      if (!INSN_P (insn))
-	continue;
-
-      pat = PATTERN (insn);
-      if (GET_CODE (pat) == SET
-	  && GET_CODE (SET_SRC (pat)) == UNSPEC_VOLATILE
-	  && (XINT (SET_SRC (pat), 1) == UNSPECV_SET_FP))
-	{
-	  set_frame_ptr_insn = insn;
-	  break;
-	}
-    }
-
-  if (set_frame_ptr_insn)
+  if (cfun->machine->set_frame_ptr_insn)
     {
+      rtx insn;
+
       /* for all instructions prior to set_frame_ptr_insn, replace
 	 hard_frame_pointer references with stack_pointer */
-      for (insn = first; insn != set_frame_ptr_insn; insn = NEXT_INSN (insn))
+      for (insn = first;
+	   insn != cfun->machine->set_frame_ptr_insn;
+	   insn = NEXT_INSN (insn))
 	{
 	  if (INSN_P (insn))
 	    PATTERN (insn) = replace_rtx (copy_rtx (PATTERN (insn)),
@@ -2379,9 +2380,8 @@
   rtx gp_regs, dest;
   int arg_words = current_function_arg_words;
   int gp_left = MAX_ARGS_IN_REGISTERS - arg_words;
-  int i;
 
-  if (gp_left == 0)
+  if (gp_left <= 0)
     return const0_rtx;
 
   /* allocate the general-purpose register space */
@@ -2394,15 +2394,10 @@
 			 plus_constant (XEXP (gp_regs, 0),
 					arg_words * UNITS_PER_WORD));
 
-  /* Note: Don't use move_block_from_reg() here because the incoming
-     argument in a7 cannot be represented by hard_frame_pointer_rtx.
-     Instead, call gen_raw_REG() directly so that we get a distinct
-     instance of (REG:SI 7). */
-  for (i = 0; i < gp_left; i++)
-    {
-      emit_move_insn (operand_subword (dest, i, 1, BLKmode),
-		      gen_raw_REG (SImode, GP_ARG_FIRST + arg_words + i));
-    }
+  cfun->machine->need_a7_copy = true;
+  cfun->machine->vararg_a7 = true;
+  move_block_from_reg (GP_ARG_FIRST + arg_words, dest, gp_left,
+		       gp_left * UNITS_PER_WORD);
 
   return XEXP (gp_regs, 0);
 }
@@ -2722,56 +2717,6 @@
 }
 
 
-/* A customized version of reg_overlap_mentioned_p that only looks for
-   references to a7 (as opposed to hard_frame_pointer_rtx). */
-
-int
-a7_overlap_mentioned_p (x)
-     rtx x;
-{
-  int i, j;
-  unsigned int x_regno;
-  const char *fmt;
-
-  if (GET_CODE (x) == REG)
-    {
-      x_regno = REGNO (x);
-      return (x != hard_frame_pointer_rtx
-	      && x_regno < A7_REG + 1
-	      && x_regno + HARD_REGNO_NREGS (A7_REG, GET_MODE (x)) > A7_REG);
-    }
-
-  if (GET_CODE (x) == SUBREG
-      && GET_CODE (SUBREG_REG (x)) == REG
-      && REGNO (SUBREG_REG (x)) < FIRST_PSEUDO_REGISTER)
-    {
-      x_regno = subreg_regno (x);
-      return (SUBREG_REG (x) != hard_frame_pointer_rtx
-	      && x_regno < A7_REG + 1
-	      && x_regno + HARD_REGNO_NREGS (A7_REG, GET_MODE (x)) > A7_REG);
-    }
-
-  /* X does not match, so try its subexpressions.  */
-  fmt = GET_RTX_FORMAT (GET_CODE (x));
-  for (i = GET_RTX_LENGTH (GET_CODE (x)) - 1; i >= 0; i--)
-    {
-      if (fmt[i] == 'e')
-	{
-	  if (a7_overlap_mentioned_p (XEXP (x, i)))
-	    return 1;
-	}
-      else if (fmt[i] == 'E')
-	{
-	  for (j = XVECLEN (x, i) - 1; j >=0; j--)
-	    if (a7_overlap_mentioned_p (XVECEXP (x, i, j)))
-	      return 1;
-	}
-    }
-
-  return 0;
-}
-
-
 /* Some Xtensa targets support multiple bss sections.  If the section
    name ends with ".bss", add SECTION_BSS to the flags.  */
 
diff -urN gcc-3.3.3.orig/gcc/config/xtensa/xtensa.h gcc-3.3.3/gcc/config/xtensa/xtensa.h
--- gcc-3.3.3.orig/gcc/config/xtensa/xtensa.h	2003-04-25 18:43:44.000000000 -0600
+++ gcc-3.3.3/gcc/config/xtensa/xtensa.h	2004-04-20 02:29:00.000000000 -0600
@@ -1,5 +1,5 @@
 /* Definitions of Tensilica's Xtensa target machine for GNU compiler.
-   Copyright 2001,2002,2003 Free Software Foundation, Inc.
+   Copyright 2001, 2002, 2003, 2004 Free Software Foundation, Inc.
    Contributed by Bob Wilson (bwilson@tensilica.com) at Tensilica.
 
 This file is part of GCC.
@@ -853,23 +853,21 @@
 #define FUNCTION_ARG_REGNO_P(N)						\
   ((N) >= GP_OUTGOING_ARG_FIRST && (N) <= GP_OUTGOING_ARG_LAST)
 
-/* Define a data type for recording info about an argument list
-   during the scan of that argument list.  This data type should
-   hold all necessary information about the function itself
-   and about the args processed so far, enough to enable macros
-   such as FUNCTION_ARG to determine where the next arg should go. */
-typedef struct xtensa_args {
-    int arg_words;		/* # total words the arguments take */
+/* Record the number of argument words seen so far, along with a flag to
+   indicate whether these are incoming arguments.  (FUNCTION_INCOMING_ARG
+   is used for both incoming and outgoing args, so a separate flag is
+   needed.  */
+typedef struct xtensa_args
+{
+  int arg_words;
+  int incoming;
 } CUMULATIVE_ARGS;
 
-/* Initialize a variable CUM of type CUMULATIVE_ARGS
-   for a call to a function whose data type is FNTYPE.
-   For a library call, FNTYPE is 0. */
 #define INIT_CUMULATIVE_ARGS(CUM, FNTYPE, LIBNAME, INDIRECT)		\
-  init_cumulative_args (&CUM, FNTYPE, LIBNAME)
+  init_cumulative_args (&CUM, 0)
 
 #define INIT_CUMULATIVE_INCOMING_ARGS(CUM, FNTYPE, LIBNAME)		\
-  init_cumulative_args (&CUM, FNTYPE, LIBNAME)
+  init_cumulative_args (&CUM, 1)
 
 /* Update the data in CUM to advance over an argument
    of mode MODE and data type TYPE.
diff -urN gcc-3.3.3.orig/gcc/config.gcc gcc-3.3.3/gcc/config.gcc
--- gcc-3.3.3.orig/gcc/config.gcc	2004-01-20 23:06:00.000000000 -0700
+++ gcc-3.3.3/gcc/config.gcc	2004-04-20 02:28:59.000000000 -0600
@@ -698,7 +698,7 @@
 	use_collect2=yes
 	;;
 arm*-*-linux*)			# ARM GNU/Linux with ELF
-	tm_file="dbxelf.h elfos.h arm/unknown-elf.h arm/elf.h arm/aout.h arm/arm.h arm/linux-gas.h arm/linux-elf.h"
+	tm_file="dbxelf.h elfos.h arm/elf.h arm/linux-gas.h arm/linux-elf.h arm/aout.h arm/arm.h"
 	tmake_file="t-slibgcc-elf-ver t-linux arm/t-linux"
 	extra_parts="crtbegin.o crtbeginS.o crtend.o crtendS.o"
 	gnu_ld=yes
@@ -2111,7 +2111,7 @@
 powerpc-*-rtems*)
 	xm_defines=POSIX
 	tm_file="${tm_file} dbxelf.h elfos.h svr4.h freebsd-spec.h rs6000/sysv4.h rs6000/eabi.h rs6000/rtems.h rtems.h"
-	tmake_file="rs6000/t-rtems t-rtems rs6000/t-ppccomm"
+	tmake_file="rs6000/t-fprules rs6000/t-rtems t-rtems rs6000/t-ppccomm"
 	if test x$enable_threads = xyes; then
 	  thread_file='rtems'
 	fi
@@ -2439,7 +2439,7 @@
 	;;
 sparc-*-linux*)		# SPARC's running GNU/Linux, libc6
 	tm_file="${tm_file} dbxelf.h elfos.h svr4.h sparc/sysv4.h sparc/linux.h"
-	tmake_file="t-slibgcc-elf-ver t-linux sparc/t-crtfm"
+	tmake_file="t-slibgcc-elf-ver t-linux sparc/t-linux sparc/t-crtfm"
 	;;
 sparc-*-lynxos*)
 	if test x$gas = xyes
@@ -2827,7 +2827,25 @@
 	# We should have hammer chip here, but it does not exist yet and
 	# thus it is not supported.  Athlon_SSE is probably equivalent feature
 	# wise to hammer from our point of view except for 64bit mode.
-	target_cpu_default2=TARGET_CPU_DEFAULT_athlon_sse
+	case "x$with_cpu" in
+		x)
+			target_cpu_default2=TARGET_CPU_DEFAULT_athlon_sse
+			;;
+		xnocona)
+			target_cpu_default2=TARGET_CPU_DEFAULT_pentium4
+			;;
+		xyes|xno)
+			echo "--with-cpu must be passed a value" 1>&2
+			exit 1
+			;;
+		*)
+			if test x$pass2done = xyes
+			then
+				echo "Unknown cpu used with --with-cpu=$with_cpu" 1>&2
+				exit 1
+			fi
+			;;
+	esac
 	;;
 alpha*-*-*)
 	case $machine in
diff -urN gcc-3.3.3.orig/gcc/config.in gcc-3.3.3/gcc/config.in
--- gcc-3.3.3.orig/gcc/config.in	2004-02-14 13:34:20.000000000 -0700
+++ gcc-3.3.3/gcc/config.in	2004-04-20 02:28:59.000000000 -0600
@@ -617,6 +617,9 @@
 /* Define if your linker supports --eh-frame-hdr option. */
 #undef HAVE_LD_EH_FRAME_HDR
 
+/* Define if your linker supports --as-needed and --no-as-needed options. */
+#undef HAVE_LD_AS_NEEDED
+
 /* Define if your MIPS libgloss linker scripts consistently include STARTUP directives. */
 #undef HAVE_MIPS_LIBGLOSS_STARTUP_DIRECTIVES
 
diff -urN gcc-3.3.3.orig/gcc/configure.in gcc-3.3.3/gcc/configure.in
--- gcc-3.3.3.orig/gcc/configure.in	2003-12-01 18:56:12.000000000 -0700
+++ gcc-3.3.3/gcc/configure.in	2004-04-20 02:28:59.000000000 -0600
@@ -2438,6 +2438,24 @@
 fi
 AC_MSG_RESULT($gcc_cv_ld_eh_frame_hdr)
 
+AC_MSG_CHECKING(linker --as-needed support)
+gcc_cv_ld_as_needed=no
+if test x$gcc_cv_gld_major_version != x -a x$gcc_cv_gld_minor_version != x; then
+  if test "$gcc_cv_gld_major_version" -eq 2 -a "$gcc_cv_gld_minor_version" -ge 16 -o "$gcc_cv_gld_major_version" -gt 2 && grep 'EMUL = elf' ../ld/Makefile > /dev/null; then
+    gcc_cv_ld_as_needed=yes
+  fi
+elif test x$gcc_cv_ld != x; then
+	# Check if linker supports --as-needed and --no-as-needed options
+	if $gcc_cv_ld --help 2>/dev/null | grep as-needed > /dev/null; then
+		gcc_cv_ld_as_needed=yes
+	fi
+fi
+if test x"$gcc_cv_ld_as_needed" = xyes; then
+	AC_DEFINE(HAVE_LD_AS_NEEDED, 1,
+[Define if your linker supports --as-needed and --no-as-needed options.])
+fi
+AC_MSG_RESULT($gcc_cv_ld_as_needed)
+
 # Miscellaneous target-specific checks.
 case "$target" in
   mips*-*-*)
diff -urN gcc-3.3.3.orig/gcc/cp/ChangeLog gcc-3.3.3/gcc/cp/ChangeLog
--- gcc-3.3.3.orig/gcc/cp/ChangeLog	2004-02-14 13:18:15.000000000 -0700
+++ gcc-3.3.3/gcc/cp/ChangeLog	2004-04-20 02:29:00.000000000 -0600
@@ -1,3 +1,133 @@
+2004-04-01  Richard Henderson  <rth@redhat.com>
+
+        PR c++/14804
+        * decl.c (cp_finish_decl): Preserve TREE_READONLY more often.
+        * typeck2.c (split_nonconstant_init): Clear TREE_READONLY.
+
+2003-03-17  Matt Austern  <austern@apple.com>
+
+	Backport:
+	PR debug/14079
+	* decl.c (add_decl_to_level): Add extern variables, as well
+	as static, to static_decls array.
+	
+2004-03-12  Gabriel Dos Reis  <gdr@integrable-solutions.net>
+
+	Backport:
+	2004-03-11  Mark Mitchell  <mark@codesourcery.com>
+	PR c++/14476
+	* decl.c (xref_tag): Do not create dummy ENUMERAL_TYPEs.
+
+2004-03-12  Gabriel Dos Reis  <gdr@integrable-solutions.net>
+
+	Backport:
+	2004-03-08  Mark Mitchell  <mark@codesourcery.com>
+	PR c++/14401
+	* class.c (check_field_decls): Complain about non-static data
+	members of reference type in unions.  Propagate
+	CLASSTYPE_REF_FIELDS_NEED_INIT and
+	CLASSTYPE_READONLY_FIELDS_NEED_INIT from the types of non-static
+	data members.
+	* init.c (perform_member_init): Complain about members with const
+	type that are not explicitly initialized.
+
+2004-03-12  Gabriel Dos Reis  <gdr@integrable-solutions.net>
+
+	Backport:
+	2004-03-09  Mark Mitchell  <mark@codesourcery.com>
+        PR c++/14230
+        * call.c (initialize_reference): Handle initializers that are
+        class-member access expressions applies to rvalues.
+
+2004-03-12  Gabriel Dos Reis  <gdr@integrable-solutions.net>
+
+	Backport:
+	2004-01-12  Richard Henderson  <rth@redhat.com>
+	PR opt/10776
+	* typeck2.c (split_nonconstant_init_1, split_nonconstant_init): New.
+	(store_init_value): Use it.
+	* decl.c (check_initializer): Expect full initialization code
+	from store_init_value.
+	* init.c (expand_aggr_init_1): Likewise.
+	* decl2.c (maybe_emit_vtables): Abort if runtime init needed.
+
+2004-03-09  Giovanni Bajo  <giovannibajo@gcc.gnu.org>
+
+	PR c++/14409
+	* pt.c (determine_specialization): For member templates, match also
+	constness.
+
+2004-03-05  Gabriel Dos Reis  <gdr@integrable-solutions.net>
+
+	Backport:
+	2004-02-04  Mark Mitchell  <mark@codesourcery.com>
+
+	PR c++/9941
+	* rtti.c (tinfo_base_init): Use import_export_tinfo to decide the
+	linkage for the typeinfo name string.
+
+2004-02-24  Jason Merrill  <jason@redhat.com>
+
+	PR c++/13944
+	* except.c (do_free_exception): Remove #if 0 wrapper.
+	(build_throw): Use it if we elide a copy into the exception object.
+
+2004-03-01  Gabriel Dos Reis  <gdr@integrable-solutions.net>
+
+	* decl.c (current_binding_level): Define as an lvalue.
+
+2004-02-23  Kriang Lerdsuwanakij  <lerdsuwa@users.sourceforge.net>
+
+	PR c++/13635
+	* pt.c (push_template_decl_real): Make sure DECL_TI_ARGS of DECL
+	has full set of arguments.
+
+2004-02-23  Giovanni Bajo  <giovannibajo@gcc.gnu.org>
+
+	PR c++/14250
+	* cvt.c (build_expr_type_conversion): Type must be complete before
+	looking up for conversions.
+
+2004-02-22  Jakub Jelinek  <jakub@redhat.com>
+
+	* decl.c (reshape_init): Convert array designator to sizetype.
+
+2004-02-22  Gabriel Dos Reis  <gdr@integrable-solutions.net>
+
+	Backport from mainline
+        2004-02-13  Mark Mitchell  <mark@codesourcery.com>
+	PR c++/14083
+	* call.c (build_conditional_expr): Call force_rvalue on the
+	non-void operand in the case that one result is a throw-expression
+	and the other is not.
+
+2004-02-22  Gabriel Dos Reis  <gdr@integrable-solutions.net>
+
+	Backport from mainline
+	2003-02-06  Giovanni Bajo  <giovannibajo@gcc.gnu.org>
+	PR c++/14033
+	* decl.c (require_complete_types_for_parms): Do not insert
+	error_mark_node in the parameter list.
+
+2004-02-22  Gabriel Dos Reis  <gdr@integrable-solutions.net>
+
+	Backport from mainline
+	2004-02-04  Mark Mitchell  <mark@codesourcery.com>
+	PR c++/13932
+	* call.c (convert_like_real): Use "converting" rather than
+	"argument" as the descriptive keyword to
+	dubious_conversion_warnings.
+	* typeck.c (convert_for_assignment): Do not call
+	dubious_conversion_warnings.
+
+2004-02-22  Gabriel Dos Reis  <gdr@integrable-solutions.net>
+
+	Backport from mainline
+	2004-02-02  Mark Mitchell  <mark@codesourcery.com>
+	PR c++/13907
+	* call.c (convert_class_to_reference): Keep better track of
+	pedantically invalid user-defined conversions.
+
 2004-02-14  Release Manager
 
 	* GCC 3.3.3 Released.
diff -urN gcc-3.3.3.orig/gcc/cp/call.c gcc-3.3.3/gcc/cp/call.c
--- gcc-3.3.3.orig/gcc/cp/call.c	2004-01-30 11:20:54.000000000 -0700
+++ gcc-3.3.3/gcc/cp/call.c	2004-04-20 02:29:00.000000000 -0600
@@ -1091,15 +1091,19 @@
 					   LOOKUP_NORMAL);
 	  
 	  if (cand)
-	    /* Build a standard conversion sequence indicating the
-	       binding from the reference type returned by the
-	       function to the desired REFERENCE_TYPE.  */
-	    cand->second_conv
-	      = (direct_reference_binding 
-		 (reference_type, 
-		  build1 (IDENTITY_CONV, 
-			  TREE_TYPE (TREE_TYPE (TREE_TYPE (cand->fn))),
-			  NULL_TREE)));
+            {
+              /* Build a standard conversion sequence indicating the
+                 binding from the reference type returned by the
+                 function to the desired REFERENCE_TYPE.  */
+              cand->second_conv
+                = (direct_reference_binding 
+                   (reference_type, 
+                    build1 (IDENTITY_CONV, 
+                            TREE_TYPE (TREE_TYPE (TREE_TYPE (cand->fn))),
+                            NULL_TREE)));
+              ICS_BAD_FLAG (cand->second_conv)
+                |= ICS_BAD_FLAG (TREE_VEC_ELT (cand->convs, 0));
+            }
 	}
       conversions = TREE_CHAIN (conversions);
     }
@@ -3239,10 +3243,20 @@
 
 	 --Both the second and the third operands have type void; the
 	   result is of type void and is an rvalue.  */
-      if ((TREE_CODE (arg2) == THROW_EXPR)
-	  ^ (TREE_CODE (arg3) == THROW_EXPR))
-	result_type = ((TREE_CODE (arg2) == THROW_EXPR) 
-		       ? arg3_type : arg2_type);
+      if (TREE_CODE (arg2) == THROW_EXPR 
+	  && TREE_CODE (arg3) != THROW_EXPR)
+	{
+	  arg3 = force_rvalue (arg3);
+	  arg3_type = TREE_TYPE (arg3);
+	  result_type = arg3_type;
+	}
+      else if (TREE_CODE (arg2) != THROW_EXPR 
+	       && TREE_CODE (arg3) == THROW_EXPR)
+	{
+	  arg2 = force_rvalue (arg2);
+	  arg2_type = TREE_TYPE (arg2);
+	  result_type = arg2_type;
+	}
       else if (VOID_TYPE_P (arg2_type) && VOID_TYPE_P (arg3_type))
 	result_type = void_type_node;
       else
@@ -4093,7 +4107,7 @@
   
   if (issue_conversion_warnings)
     expr = dubious_conversion_warnings
-             (totype, expr, "argument", fn, argnum);
+             (totype, expr, "converting", fn, argnum);
   switch (TREE_CODE (convs))
     {
     case USER_CONV:
@@ -6190,6 +6204,16 @@
 	  type = TREE_TYPE (expr);
 	  var = make_temporary_var_for_ref_to_temp (decl, type);
 	  layout_decl (var, 0);
+	  /* If the rvalue is the result of a function call it will be
+	     a TARGET_EXPR.  If it is some other construct (such as a
+	     member access expression where the underlying object is
+	     itself the result of a function call), turn it into a
+	     TARGET_EXPR here.  It is important that EXPR be a
+	     TARGET_EXPR below since otherwise the INIT_EXPR will
+	     attempt to make a bitwise copy of EXPR to intialize
+	     VAR. */
+	  if (TREE_CODE (expr) != TARGET_EXPR)
+	    expr = get_target_expr (expr);
 	  /* Create the INIT_EXPR that will initialize the temporary
 	     variable.  */
 	  init = build (INIT_EXPR, type, var, expr);
diff -urN gcc-3.3.3.orig/gcc/cp/class.c gcc-3.3.3/gcc/cp/class.c
--- gcc-3.3.3.orig/gcc/cp/class.c	2004-01-20 22:52:28.000000000 -0700
+++ gcc-3.3.3/gcc/cp/class.c	2004-04-20 02:29:00.000000000 -0600
@@ -3231,9 +3231,30 @@
 
       /* If we've gotten this far, it's a data member, possibly static,
 	 or an enumerator.  */
-
       DECL_CONTEXT (x) = t;
 
+      /* When this goes into scope, it will be a non-local reference.  */
+      DECL_NONLOCAL (x) = 1;
+
+      if (TREE_CODE (t) == UNION_TYPE)
+	{
+	  /* [class.union]
+
+	     If a union contains a static data member, or a member of
+	     reference type, the program is ill-formed. */
+	  if (TREE_CODE (x) == VAR_DECL)
+	    {
+	      cp_error_at ("`%D' may not be static because it is a member of a union", x);
+	      continue;
+	    }
+	  if (TREE_CODE (type) == REFERENCE_TYPE)
+	    {
+	      cp_error_at ("`%D' may not have reference type `%T' because it is a member of a union",
+			   x, type);
+	      continue;
+	    }
+	}
+
       /* ``A local class cannot have static data members.'' ARM 9.4 */
       if (current_function_decl && TREE_STATIC (x))
 	cp_error_at ("field `%D' in local class cannot be static", x);
@@ -3263,21 +3284,9 @@
       if (type == error_mark_node)
 	continue;
 	  
-      /* When this goes into scope, it will be a non-local reference.  */
-      DECL_NONLOCAL (x) = 1;
-
-      if (TREE_CODE (x) == CONST_DECL)
+      if (TREE_CODE (x) == CONST_DECL || TREE_CODE (x) == VAR_DECL)
 	continue;
 
-      if (TREE_CODE (x) == VAR_DECL)
-	{
-	  if (TREE_CODE (t) == UNION_TYPE)
-	    /* Unions cannot have static members.  */
-	    cp_error_at ("field `%D' declared static in union", x);
-	      
-	  continue;
-	}
-
       /* Now it can only be a FIELD_DECL.  */
 
       if (TREE_PRIVATE (x) || TREE_PROTECTED (x))
@@ -3308,6 +3317,14 @@
       if (TREE_CODE (type) == POINTER_TYPE)
 	has_pointers = 1;
 
+      if (CLASS_TYPE_P (type))
+        {
+          if (CLASSTYPE_REF_FIELDS_NEED_INIT (type))
+            SET_CLASSTYPE_REF_FIELDS_NEED_INIT (t, 1);
+          if (CLASSTYPE_READONLY_FIELDS_NEED_INIT (type))
+            SET_CLASSTYPE_READONLY_FIELDS_NEED_INIT (t, 1);
+        }
+
       if (DECL_MUTABLE_P (x) || TYPE_HAS_MUTABLE_P (type))
 	CLASSTYPE_HAS_MUTABLE (t) = 1;
 
diff -urN gcc-3.3.3.orig/gcc/cp/cvt.c gcc-3.3.3/gcc/cp/cvt.c
--- gcc-3.3.3.orig/gcc/cp/cvt.c	2003-03-28 17:50:09.000000000 -0700
+++ gcc-3.3.3/gcc/cp/cvt.c	2004-04-20 02:29:00.000000000 -0600
@@ -1073,8 +1073,9 @@
 
   /* The code for conversions from class type is currently only used for
      delete expressions.  Other expressions are handled by build_new_op.  */
-
-  if (! TYPE_HAS_CONVERSION (basetype))
+  if (!complete_type_or_else (basetype, expr))
+    return error_mark_node;
+  if (!TYPE_HAS_CONVERSION (basetype))
     return NULL_TREE;
 
   for (conv = lookup_conversions (basetype); conv; conv = TREE_CHAIN (conv))
